## quassel-qt5 0.14.0~pre-130-g01d67be2-1

=== CMakeLists.txt ===
# Main CMake file for building Quassel IRC
#
# See INSTALL for possible CMake options (or read the code, Luke)
#####################################################################

# General setup
#####################################################################

cmake_minimum_required(VERSION 3.5)

# Tell CMake about or own modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

include(QuasselVersion)

message(STATUS "Using CMake ${CMAKE_VERSION}")

# Set up build type rather early
include(BuildType)

# Support ccache if found
# This should happen before calling project(), so compiler settings are validated.
option(USE_CCACHE "Enable support for ccache if available" ON)
if (USE_CCACHE)
    message(STATUS "Checking for ccache")
    find_program(CCACHE_PROGRAM ccache)
    if (CCACHE_PROGRAM)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
        message(STATUS "Checking for ccache - enabled")
    else()
        message(STATUS "Checking for ccache - not found")
    endif()
endif()

# Set up project
project(Quassel CXX)

# Let CMake handle file generation for Qt
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# Needed, otherwise some .moc files won't be found with older CMake versions
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include various CMake modules...
include(CMakePushCheckState)
include(CheckFunctionExists)
include(CheckIncludeFileCXX)
include(CheckCXXSourceCompiles)
include(CMakeDependentOption)
include(FeatureSummary)

# ... and our own
include(QuasselCompileSettings)
include(QuasselMacros)

# Options and variables that can be set on the command line
#####################################################################

# Select the binaries to build
option(WANT_CORE     "Build the core (server) binary"           ON)
option(WANT_QTCLIENT "Build the client-only binary"             ON)
option(WANT_MONO     "Build the monolithic (all-in-one) binary" ON)
add_feature_info(WANT_CORE WANT_CORE "Build the core (server) binary")
add_feature_info(WANT_QTCLIENT WANT_QTCLIENT "Build the client-only binary (requires a core to connect to)")
add_feature_info(WANT_MONO WANT_MONO "Build the monolithic (all-in-one) binary")

# Whether to enable integration with higher-tier KDE frameworks that require runtime support.
# We still optionally make use of certain Tier 1 frameworks even if WITH_KDE is disabled.
option(WITH_KDE "Integration with the KDE Frameworks runtime environment")
add_feature_info(WITH_KDE WITH_KDE "Integrate with the KDE Frameworks runtime environment")

# Icon theme support. By default, install the Breeze icon theme (may be disabled if a system installation is present)
option(WITH_BUNDLED_ICONS "Install required icons from the Breeze icon theme" ON)
add_feature_info(WITH_BUNDLED_ICONS WITH_BUNDLED_ICONS "Install required icons from the Breeze icon theme")

option(WITH_OXYGEN_ICONS "Support the Oxygen icon theme (KDE4)" OFF)
add_feature_info(WITH_OXYGEN_ICONS WITH_OXYGEN_ICONS "Support the Oxygen icon theme (KDE4)")

# For this, the feature info is added after we know if QtWebkit is installed
option(WITH_WEBKIT "WebKit support (for link previews) (legacy)" OFF)

# For this, the feature info is added after we know if QtWebEngine is installed
option(WITH_WEBENGINE "WebEngine support (for link previews)" ON)

if (APPLE)
    # Notification Center is only available in > 10.8, which is Darwin v12
    if (NOT CMAKE_SYSTEM_VERSION VERSION_LESS 12)
        option(WITH_NOTIFICATION_CENTER "OS X Notification Center support" ON)
        add_feature_info(WITH_NOTIFICATION_CENTER WITH_NOTIFICATION_CENTER "Use the OS X Notification Center")
    endif()
    find_library(CARBON_LIBRARY Carbon)
    mark_as_advanced(CARBON_LIBRARY)
    link_libraries(${CARBON_LIBRARY})
endif()

# Always embed on Windows or OSX; never embed when enabling KDE integration
set(EMBED_DEFAULT OFF)
if (WIN32 OR APPLE)
    set(EMBED_DEFAULT ON)
endif()
cmake_dependent_option(EMBED_DATA "Embed icons and translations into the binaries instead of installing them" ${EMBED_DEFAULT}
                                   "NOT WIN32;NOT WITH_KDE" ${EMBED_DEFAULT})
if (NOT EMBED_DEFAULT)
    add_feature_info(EMBED_DATA EMBED_DATA "Embed icons and translations in the binaries instead of installing them")
endif()

# The following options are not for end-user consumption, so don't list them in the feature summary
option(FATAL_WARNINGS "Make compile warnings fatal (most useful for CI builds)" OFF)
cmake_dependent_option(DEPLOY "Add required libs to bundle resources and create a dmg" OFF "APPLE" OFF)

# List of authenticators and the cmake flags to build them
# (currently that's just LDAP, but more can be added here).
####################################################################
option(WITH_LDAP "Enable LDAP authentication support if present on system" ON)

# Setup CMake
#####################################################################

# Visibility settings apply to all targets
if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()

# Let automoc/autouic process generated files
if (POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()

set(BUILD_SHARED_LIBS TRUE CACHE BOOL "" FORCE)

# Don't use X11 on OSX
if (APPLE)
    set(CMAKE_DISABLE_FIND_PACKAGE_X11 true)
    set(CMAKE_DISABLE_FIND_PACKAGE_XCB true)
    set(CMAKE_DISABLE_FIND_PACKAGE_Qt5X11Extras true)
endif()

# Simplify later checks
#####################################################################

if (WANT_MONO OR WANT_QTCLIENT)
    set(BUILD_GUI true)
endif()
if (WANT_MONO OR WANT_CORE)
    set(BUILD_CORE true)
endif()

# Set up Qt
#####################################################################

# Find package dependencies
#
# Note that you can forcefully disable optional packages
# using -DCMAKE_DISABLE_FIND_PACKAGE_<PkgName>=TRUE
#####################################################################

set(QT_MIN_VERSION "5.5.0")

# Required Qt components
set(qt_components Core Network)
if (BUILD_GUI)
    list(APPEND qt_components Gui Widgets)
endif()
if (BUILD_CORE)
    list(APPEND qt_components Script Sql)
endif()

find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS ${qt_components})
set_package_properties(Qt5 PROPERTIES TYPE REQUIRED
    URL "https://www.qt.io/"
    DESCRIPTION "the Qt libraries"
)
message(STATUS "Found Qt ${Qt5Core_VERSION}")

# Optional Qt components

find_package(Qt5LinguistTools QUIET)
set_package_properties(Qt5LinguistTools PROPERTIES TYPE RECOMMENDED
    DESCRIPTION "contains tools for handling translation files"
    PURPOSE "Required for having translations"
)

if (BUILD_GUI)
    if (NOT WIN32)
        find_package(Qt5DBus QUIET)
        set_package_properties(Qt5DBus PROPERTIES TYPE RECOMMENDED
            URL "https://www.qt.io/"
            DESCRIPTION "D-Bus support for Qt5"
            PURPOSE     "Needed for supporting D-Bus-based notifications and tray icon, used by most modern desktop environments"
        )
        if (Qt5DBus_FOUND)
            find_package(dbusmenu-qt5 QUIET CONFIG)
            set_package_properties(dbusmenu-qt5 PROPERTIES TYPE RECOMMENDED
                URL "https://launchpad.net/libdbusmenu-qt"
                DESCRIPTION "a library implementing the DBusMenu specification"
                PURPOSE     "Required for having a context menu for the D-Bus-based tray icon"
            )
        endif()
    endif()

    find_package(Qt5Multimedia QUIET)
    set_package_properties(Qt5Multimedia PROPERTIES TYPE RECOMMENDED
        URL "https://www.qt.io/"
        DESCRIPTION "Multimedia support for Qt5"
        PURPOSE     "Required for audio notifications"
    )

    find_package(LibsnoreQt5 0.7.0 QUIET)
    set_package_properties(LibsnoreQt5 PROPERTIES TYPE OPTIONAL
        URL "https://projects.kde.org/projects/playground/libs/snorenotify"
        DESCRIPTION "a cross-platform notification framework"
        PURPOSE     "Enable support for the snorenotify framework"
    )
    if (LibsnoreQt5_FOUND)
        find_package(LibsnoreSettingsQt5 QUIET)
        set_package_properties(LibsnoreSettingsQt5 PROPERTIES TYPE OPTIONAL
            URL "https://projects.kde.org/projects/playground/libs/snorenotify"
            DESCRIPTION "a cross-platform notification framework"
            PURPOSE     "Enable support for the snorenotify framework"
        )
    endif()

    if (WITH_WEBENGINE)
        find_package(Qt5WebEngine QUIET)
        set_package_properties(Qt5WebEngine PROPERTIES TYPE RECOMMENDED
            URL "https://www.qt.io/"
            DESCRIPTION "a WebEngine implementation for Qt"
            PURPOSE     "Needed for displaying previews for URLs in chat"
        )
        if (Qt5WebEngine_FOUND)
            find_package(Qt5WebEngineWidgets QUIET)
            set_package_properties(Qt5WebEngineWidgets PROPERTIES TYPE RECOMMENDED
                URL "https://www.qt.io/"
                DESCRIPTION "widgets for Qt's WebEngine implementation"
                PURPOSE     "Needed for displaying previews for URLs in chat"
            )
        endif()
    endif()

    if (WITH_WEBENGINE AND Qt5WebEngineWidgets_FOUND)
        set(HAVE_WEBENGINE true)
    endif()
    add_feature_info("WITH_WEBENGINE, QtWebEngine and QtWebEngineWidgets modules" HAVE_WEBENGINE "Support showing previews for URLs in chat")

    if (NOT HAVE_WEBENGINE)
        if (WITH_WEBKIT)
            find_package(Qt5WebKit QUIET)
            set_package_properties(Qt5WebKit PROPERTIES TYPE OPTIONAL
                URL "https://www.qt.io/"
                DESCRIPTION "a WebKit implementation for Qt"
                PURPOSE     "Needed for displaying previews for URLs in chat"
                )
            if (Qt5WebKit_FOUND)
                find_package(Qt5WebKitWidgets QUIET)
                set_package_properties(Qt5WebKitWidgets PROPERTIES TYPE OPTIONAL
                    URL "https://www.qt.io/"
                    DESCRIPTION "widgets for Qt's WebKit implementation"
                    PURPOSE     "Needed for displaying previews for URLs in chat"
                    )
            endif()
        endif()

        if (WITH_WEBKIT AND Qt5WebKitWidgets_FOUND)
            set(HAVE_WEBKIT true)
        endif()
        add_feature_info("WITH_WEBKIT, QtWebKit and QtWebKitWidgets modules" HAVE_WEBKIT "Support showing previews for URLs in chat (legacy)")
    endif()

    # KDE Frameworks
    ################

    # extra-cmake-modules
    if (WITH_KDE)
        set(ecm_find_type "REQUIRED")
        find_package(ECM NO_MODULE REQUIRED)
    else()
        # Even with KDE integration disabled, we optionally use tier1 frameworks if we find them
        set(ecm_find_type "RECOMMENDED")
        find_package(ECM NO_MODULE QUIET)
    endif()

    set_package_properties(ECM PROPERTIES TYPE ${ecm_find_type}
        URL "https://projects.kde.org/projects/kdesupport/extra-cmake-modules"
        DESCRIPTION "extra modules for CMake, maintained by the KDE project"
        PURPOSE     "Required to find KDE Frameworks components"
    )

    if (ECM_FOUND)
        list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
        if (WITH_KDE)
            find_package(KF5 REQUIRED COMPONENTS ConfigWidgets CoreAddons Notifications NotifyConfig Sonnet TextWidgets WidgetsAddons XmlGui)
            set_package_properties(KF5 PROPERTIES TYPE REQUIRED
                URL "http://www.kde.org"
                DESCRIPTION "KDE Frameworks"
                PURPOSE     "Required for integration into the Plasma desktop"
            )
            message(STATUS "Found KDE Frameworks ${KF5_VERSION}")
        endif()

        # Optional KF5 tier1 components
        find_package(KF5Sonnet QUIET)
        set_package_properties(KF5Sonnet PROPERTIES TYPE RECOMMENDED
            URL "http://api.kde.org/frameworks-api/frameworks5-apidocs/sonnet/html"
            DESCRIPTION "framework for providing spell-checking capabilities"
            PURPOSE "Enables spell-checking support in input widgets"
        )
    endif()

=== data/CMakeLists.txt ===
if (BUILD_GUI)
    if (UNIX AND NOT APPLE)
        if (WANT_QTCLIENT)
            install(FILES quasselclient.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
        endif()

        if (WANT_MONO)
            install(FILES quassel.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
        endif()

        if (WITH_KF5)
            install(FILES quassel.notifyrc DESTINATION ${CMAKE_INSTALL_KNOTIFY5RCDIR})
        endif()
    endif()

    if (EMBED_DATA)
        quassel_add_resource(Data PREFIX data PATTERNS
            networks.ini
            stylesheets/default.qss
        )
    else()
        install(FILES networks.ini DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel)
        install(DIRECTORY stylesheets DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel)
    endif()

    if (NOT WIN32)
        install(DIRECTORY scripts DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel USE_SOURCE_PERMISSIONS)
    endif()
endif()

=== icons/CMakeLists.txt ===
# Install icons

if (WANT_MONO OR WANT_QTCLIENT)
    if (NOT WITH_BUNDLED_ICONS AND NOT WITH_OXYGEN_ICONS)
        message(WARNING "Not including bundled icon themes. Ensure that the Breeze or Oxygen icon theme is installed!")
    endif()

    set(BUNDLED_ICON_THEME_DIR ${CMAKE_SOURCE_DIR}/3rdparty/icons)

    # Always embed a hicolor fallback containing the most important (e.g. tray) icons.
    # The .qrc contains aliases, so it's best to keep this manually written rather than autogenerated.
    quassel_add_module(Resource::HicolorIcons STATIC)
    target_sources(${TARGET} PRIVATE hicolor_icons.qrc)
    set_target_properties(${TARGET} PROPERTIES AUTOMOC OFF AUTOUIC OFF)

    if (EMBED_DATA)
        # Always embed quassel-specific icons
        message(STATUS "Embedding Quassel-specific icons")
        set(patterns breeze*/*.svg)
        if (WITH_OXYGEN_ICONS)
            list(APPEND patterns oxygen/*.png)
        endif()
        quassel_add_resource(Icons PREFIX icons PATTERNS ${patterns})

        if (WITH_BUNDLED_ICONS)
            message(STATUS "Embedding bundled Breeze icon theme")
            set(patterns breeze*/*.svg breeze*/index.theme)
            if (WITH_OXYGEN_ICONS)
                message(STATUS "Embedding bundled Oxygen icon theme")
                list(APPEND patterns oxygen/*.png oxygen/index.theme)
            endif()
        endif()
        quassel_add_resource(IconThemes PREFIX icons PATTERNS ${patterns} BASEDIR ${BUNDLED_ICON_THEME_DIR})

    else()
        # Always install quassel-specific icons
        install(DIRECTORY breeze breeze-dark DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
        if (WITH_OXYGEN_ICONS)
            install(DIRECTORY oxygen DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
        endif()

        # Install bundled icon themes into our data dir (instead of CMAKE_INSTALL_ICONDIR) to avoid conflicts
        # with themes provided by the system
        if (WITH_BUNDLED_ICONS)
            message(STATUS "Installing bundled Breeze icon theme")
            install(DIRECTORY   ${BUNDLED_ICON_THEME_DIR}/breeze
                                ${BUNDLED_ICON_THEME_DIR}/breeze-dark
                    DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons
            )
            if (WITH_OXYGEN_ICONS)
                message(STATUS "Installing bundled Oxygen icon theme")
                install(DIRECTORY ${BUNDLED_ICON_THEME_DIR}/oxygen DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
            endif()
        endif()
    endif()

    # Application icon
    if (HAVE_KDE OR (UNIX AND NOT APPLE))
        # hicolor contains the application icon in all relevant sizes
        install(DIRECTORY hicolor DESTINATION ${CMAKE_INSTALL_ICONDIR})

        if (Qt5Core_VERSION VERSION_LESS 5.5.0)
            # Qt < 5.5 doesn't seem to correctly load icons from injected themes
            # Install Quassel-specific ones from Oxygen into hicolor as fallback
            install(DIRECTORY oxygen/ DESTINATION ${CMAKE_INSTALL_ICONDIR}/hicolor)
        endif()

        # For a system install, also copy to pixmaps
        if (CMAKE_INSTALL_PREFIX STREQUAL "/usr")
            install(FILES hicolor/48x48/apps/quassel.png DESTINATION /usr/share/pixmaps)
        endif()
    endif()
endif()

=== pics/CMakeLists.txt ===
# pics/ contains non-themed icons and other graphical resources

if (WANT_MONO OR WANT_QTCLIENT)
    quassel_add_resource(Pics PREFIX pics PATTERNS
        kde-vdg.png
        quassel-64.svg
        quassel-eye.png
        quassel-logo.png
        quassel-oxygen-32.png
        qt-logo-32.png
    )
endif()

=== po/CMakeLists.txt ===
# Generate translations
# The LINGUAS environment variable can be used to limit the set of supported languages

# Generate a .ts file from a .po file
function(generate_ts basename)
    set(pofile ${CMAKE_CURRENT_SOURCE_DIR}/${basename}.po)
    set(tsfile ${CMAKE_CURRENT_BINARY_DIR}/${basename}.ts)

    add_custom_command(VERBATIM
        COMMENT "Preparing translation for language '${basename}'"
        COMMAND $<TARGET_FILE:Qt5::lconvert> -i ${pofile} -target-language ${basename} -of ts -o ${tsfile}
        DEPENDS ${pofile}
        OUTPUT  ${tsfile}
    )
endfunction()

# Clear variables just in case
set(tsfiles )
set(qmfiles )
set(linguas )

if (TARGET Qt5::lconvert)
    # LINGUAS can be used to limit the included languages
    set(LINGUAS "$ENV{LINGUAS}")
    # Normalize and convert into list
    string(REGEX REPLACE "[ \t,;]+" ";" LINGUAS "${LINGUAS}")

    # We support xx.po and xx_YY.po, and additionally translations for qt using qt_xx.po or qt_xx_YY.po
    file(GLOB pofiles *.po)
    foreach(pofile ${pofiles})
        get_filename_component(basename ${pofile} NAME_WE)
        # CMake can't use MATCH to get the second catch...
        string(REGEX REPLACE "(qt_)?([a-zA-Z]+)(_.+)?$" "\\2" lang ${basename})
        # Test if we want this language
        set(idx 0)
        if(LINGUAS)
            list(FIND LINGUAS ${lang} idx)  # idx will be -1 if ${lang} is not found in LINGUAS
        endif()
        if(idx GREATER -1)
            generate_ts(${basename})
            list(APPEND tsfiles ${CMAKE_CURRENT_BINARY_DIR}/${basename}.ts)
            list(APPEND qmfiles ${CMAKE_CURRENT_BINARY_DIR}/${basename}.qm)
            list(APPEND linguas ${lang})
        endif()
    endforeach()

    if (tsfiles)
        # Synchronize the (possibly outdated) .ts files with the current source tree
        add_custom_command(VERBATIM
            COMMENT "Syncing translations"
            COMMAND $<TARGET_FILE:Qt5::lupdate> -silent ${CMAKE_SOURCE_DIR}/src -ts ${tsfiles}
            COMMAND ${CMAKE_COMMAND} -E touch tsfiles.done
            DEPENDS ${tsfiles}
            OUTPUT tsfiles.depends
        )

        # Generate the final translation files (.qm) for use by Qt
        add_custom_command(VERBATIM
            COMMENT "Compressing translations"
            COMMAND $<TARGET_FILE:Qt5::lrelease> -silent ${tsfiles}
            DEPENDS tsfiles.depends
            OUTPUT ${qmfiles}
        )

        # Curate the language list and give diagnostic output
        list(REMOVE_DUPLICATES linguas)
        list(SORT linguas)
        string(REPLACE ";" ", " linguas_string "${linguas}")
        message(STATUS "Enabling translations for: ${linguas_string}")
    else()
        message(STATUS "No translations enabled")
    endif()
else()
    message(WARNING "Qt Linguist Tools not found, you won't have translations!")
endif()

# Always generate translations
add_custom_target(translations ALL DEPENDS ${qmfiles})

if (EMBED_DATA)
    quassel_add_resource(I18n PREFIX i18n BASEDIR ${CMAKE_CURRENT_BINARY_DIR} PATTERNS ${qmfiles} DEPENDS translations)
else()
    install(FILES ${qmfiles} DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/translations)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(main)
if (BUILD_CORE)
    add_subdirectory(core)
endif()
if (BUILD_GUI)
    add_subdirectory(client)
    add_subdirectory(uisupport)
    add_subdirectory(qtui)
endif()

if (BUILD_TESTING)
    add_subdirectory(test)
endif()

=== src/common/CMakeLists.txt ===
quassel_add_module(Common EXPORT)

target_sources(${TARGET} PRIVATE
    abstractsignalwatcher.h
    aliasmanager.cpp
    authhandler.cpp
    backlogmanager.cpp
    basichandler.cpp
    bufferinfo.cpp
    buffersyncer.cpp
    bufferviewconfig.cpp
    bufferviewmanager.cpp
    compressor.cpp
    coreinfo.cpp
    ctcpevent.cpp
    dccconfig.cpp
    event.cpp
    eventmanager.cpp
    expressionmatch.cpp
    funchelpers.h
    highlightrulemanager.cpp
    identity.cpp
    ignorelistmanager.cpp
    internalpeer.cpp
    ircchannel.cpp
    ircevent.cpp
    irclisthelper.cpp
    ircuser.cpp
    logger.cpp
    message.cpp
    messageevent.cpp
    network.cpp
    networkconfig.cpp
    networkevent.cpp
    nickhighlightmatcher.cpp
    peer.cpp
    peerfactory.cpp
    presetnetworks.cpp
    quassel.cpp
    remotepeer.cpp
    settings.cpp
    signalproxy.cpp
    singleton.h
    syncableobject.cpp
    transfer.cpp
    transfermanager.cpp
    types.cpp
    util.cpp

    serializers/serializers.cpp

    protocols/datastream/datastreampeer.cpp
    protocols/legacy/legacypeer.cpp

    # needed for automoc
    irccap.h
    protocol.h
)

# Needed for finding the generated version.h
target_include_directories(${TARGET} PRIVATE ${CMAKE_BINARY_DIR})

target_link_libraries(${TARGET} PUBLIC
    ${CMAKE_DL_LIBS}
    Boost::boost
    Qt5::Core
    Qt5::Network
    ZLIB::ZLIB
)

if (EMBED_DATA)
    set_property(SOURCE quassel.cpp APPEND PROPERTY COMPILE_DEFINITIONS EMBED_DATA)
endif()

if (HAVE_SYSLOG)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_SYSLOG)
endif()

if (WIN32)
    target_sources(${TARGET} PRIVATE logbacktrace_win.cpp windowssignalwatcher.cpp)
else()
    if (Backtrace_FOUND)
        configure_file(backtrace_config.h.in backtrace_config.h)
        target_include_directories(${TARGET} PRIVATE ${Backtrace_INCLUDE_DIRS})
        target_link_libraries(${TARGET} PRIVATE ${Backtrace_LIBRARIES})
        set_property(SOURCE logbacktrace_unix.cpp posixsignalwatcher.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_BACKTRACE)
    endif()
    target_sources(${TARGET} PRIVATE logbacktrace_unix.cpp posixsignalwatcher.cpp)
endif()

if (APPLE)
    target_sources(${TARGET} PRIVATE mac_utils.cpp)
    target_link_libraries(${TARGET} PUBLIC "-framework CoreServices" "-framework CoreFoundation")
endif()

target_link_if_exists(${TARGET} PUBLIC Quassel::Resource::I18n)

=== src/core/CMakeLists.txt ===
quassel_add_module(Core EXPORT)

target_sources(${TARGET} PRIVATE
    abstractsqlstorage.cpp
    authenticator.cpp
    core.cpp
    corealiasmanager.cpp
    coreapplication.cpp
    coreauthhandler.cpp
    corebacklogmanager.cpp
    corebasichandler.cpp
    corebuffersyncer.cpp
    corebufferviewconfig.cpp
    corebufferviewmanager.cpp
    coredccconfig.cpp
    corehighlightrulemanager.cpp
    coreidentity.cpp
    coreignorelistmanager.cpp
    coreircchannel.cpp
    coreirclisthelper.cpp
    coreircuser.cpp
    corenetwork.cpp
    corenetworkconfig.cpp
    coresession.cpp
    coresessioneventprocessor.cpp
    coresettings.cpp
    coretransfer.cpp
    coretransfermanager.cpp
    coreuserinputhandler.cpp
    coreusersettings.cpp
    ctcpparser.cpp
    eventstringifier.cpp
    identserver.cpp
    ircparser.cpp
    netsplit.cpp
    oidentdconfiggenerator.cpp
    postgresqlstorage.cpp
    sessionthread.cpp
    sqlauthenticator.cpp
    sqlitestorage.cpp
    storage.cpp

    # needed for automoc
    coreeventmanager.h
)

target_link_libraries(${TARGET}
    PUBLIC
        Qt5::Core
        Qt5::Network
        Qt5::Script
        Qt5::Sql
        Quassel::Common
)

if (HAVE_UMASK)
    set_property(SOURCE oidentdconfiggenerator.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_UMASK)
endif()

if (HAVE_SSL)
    target_sources(${TARGET} PRIVATE sslserver.cpp)
endif()

if (Ldap_FOUND)
    target_sources(${TARGET} PRIVATE ldapauthenticator.cpp)
    target_link_libraries(${TARGET} PRIVATE Ldap::Ldap)
    set_property(SOURCE core.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_LDAP)
endif()

if (Qca-qt5_FOUND)
    target_sources(${TARGET} PRIVATE cipher.cpp keyevent.cpp)
    target_link_libraries(${TARGET} PUBLIC qca-qt5)
    target_compile_definitions(${TARGET} PUBLIC -DHAVE_QCA2)
endif()

quassel_add_resource(Sql PATTERNS SQL/*.sql)
target_link_libraries(${TARGET} PUBLIC Quassel::Resource::Sql)

=== src/main/CMakeLists.txt ===
# Convenience function to avoid boilerplate
function(setup_executable _target _define)
    set_target_properties(${_target} PROPERTIES
        COMPILE_FLAGS ${_define}
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
    )
    target_link_libraries(${_target} PRIVATE ${ARGN})
    install(TARGETS ${_target} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endfunction()

if (HAVE_UMASK)
    set_property(SOURCE main.cpp APPEND PROPERTY COMPILE_DEFINITIONS HAVE_UMASK)
endif()

if (WITH_BUNDLED_ICONS)
    set_property(SOURCE main.cpp APPEND PROPERTY COMPILE_DEFINITIONS WITH_BUNDLED_ICONS)
endif()

# Windows icon resource
if(WIN32)
    if(MINGW)
        find_program(WINDRES_EXECUTABLE NAMES windres)
        if(WINDRES_EXECUTABLE)
            exec_program(windres
                ARGS "-i ${CMAKE_SOURCE_DIR}/pics/win32.rc"
                     "-o ${CMAKE_CURRENT_BINARY_DIR}/win32.o"
                     "--include-dir=${CMAKE_SOURCE_DIR}/pics"
                )
            set(WIN_RC ${CMAKE_CURRENT_BINARY_DIR}/win32.o)
        endif()
    else()
        set(WIN_RC ${CMAKE_SOURCE_DIR}/pics/win32.rc)
    endif()
endif()


# Build the executables
if (WANT_CORE)
    add_executable(quasselcore main.cpp ${WIN_RC})
    setup_executable(quasselcore -DBUILD_CORE Qt5::Core Quassel::Core)
endif()

if (WANT_QTCLIENT)
    add_executable(quasselclient WIN32 main.cpp ${WIN_RC})
    setup_executable(quasselclient -DBUILD_QTUI Qt5::Core Qt5::Gui Quassel::QtUi)
    if (WITH_KDE)
        target_link_libraries(quasselclient PRIVATE KF5::CoreAddons)
    endif()
endif()

if (WANT_MONO)
    add_executable(quassel WIN32 main.cpp monoapplication.cpp ${WIN_RC})
    setup_executable(quassel -DBUILD_MONO Qt5::Core Qt5::Gui Quassel::Core Quassel::QtUi)
    if (WITH_KDE)
        target_link_libraries(quassel PRIVATE KF5::CoreAddons)
    endif()
endif()

# Build bundles for MacOSX
if (APPLE)
    if (WANT_QTCLIENT)
        add_custom_command(TARGET quasselclient POST_BUILD
                           COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                                   ${CMAKE_SOURCE_DIR} "Quassel Client" ${CMAKE_BINARY_DIR}/quasselclient)
    endif()
    if (WANT_MONO)
        add_custom_command(TARGET quassel POST_BUILD
                           COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                                   ${CMAKE_SOURCE_DIR} "Quassel" ${CMAKE_BINARY_DIR}/quassel)
    endif()

    if (DEPLOY)
        if (WANT_QTCLIENT)
            add_custom_command(TARGET quasselclient POST_BUILD WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                               COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Client ${CMAKE_BINARY_DIR} qsvgicon)
        endif()
        if (WANT_CORE)
            add_custom_command(TARGET quasselcore POST_BUILD WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                               COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Core ${CMAKE_BINARY_DIR})
        endif()
        if (WANT_MONO)
            add_custom_command(TARGET quassel POST_BUILD WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                               COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Mono ${CMAKE_BINARY_DIR} qsvgicon)
        endif()
    endif()
endif()

=== src/qtui/CMakeLists.txt ===
quassel_add_module(QtUi EXPORT)

target_sources(${TARGET} PRIVATE
    aboutdlg.cpp
    awaylogfilter.cpp
    awaylogview.cpp
    bufferwidget.cpp
    channellistdlg.cpp
    chatitem.cpp
    chatline.cpp
    chatlinemodel.cpp
    chatlinemodelitem.cpp
    chatmonitorfilter.cpp
    chatmonitorview.cpp
    chatscene.cpp
    chatview.cpp
    chatviewsearchbar.cpp
    chatviewsearchcontroller.cpp
    chatviewsettings.cpp
    columnhandleitem.cpp
    coreconfigwizard.cpp
    coreconnectdlg.cpp
    coreconnectionstatuswidget.cpp
    coreinfodlg.cpp
    coresessionwidget.cpp
    debugbufferviewoverlay.cpp
    debugconsole.cpp
    debuglogdlg.cpp
    debugmessagemodelfilter.cpp
    inputwidget.cpp
    ircconnectionwizard.cpp
    legacysystemtray.cpp
    mainpage.cpp
    mainwin.cpp
    markerlineitem.cpp
    msgprocessorstatuswidget.cpp
    nicklistwidget.cpp
    passwordchangedlg.cpp
    qtui.cpp
    qtuiapplication.cpp
    qtuimessageprocessor.cpp
    qtuisettings.cpp
    qtuistyle.cpp
    receivefiledlg.cpp
    resourcetreedlg.cpp
    settingsdlg.cpp
    settingspagedlg.cpp
    simplenetworkeditor.cpp
    systemtray.cpp
    systrayanimationnotificationbackend.cpp
    systraynotificationbackend.cpp
    taskbarnotificationbackend.cpp
    titlesetter.cpp
    topicwidget.cpp
    verticaldock.cpp
    webpreviewitem.cpp

    # UI files
    aboutdlg.ui
    bufferviewwidget.ui
    bufferwidget.ui
    channellistdlg.ui
    chatviewsearchbar.ui
    coreconfigwizardintropage.ui
    coreconfigwizardauthenticationselectionpage.ui
    coreconfigwizardadminuserpage.ui
    coreconfigwizardstorageselectionpage.ui
    coreconfigwizardsyncpage.ui
    coreconnectauthdlg.ui
    coreconnectionstatuswidget.ui
    coreinfodlg.ui
    coresessionwidget.ui
    debugbufferviewoverlay.ui
    debugconsole.ui
    debuglogdlg.ui
    inputwidget.ui
    msgprocessorstatuswidget.ui
    nicklistwidget.ui
    passwordchangedlg.ui
    receivefiledlg.ui
    resourcetreedlg.ui
    settingsdlg.ui
    settingspagedlg.ui
    simplenetworkeditor.ui
    systrayanimationconfigwidget.ui
    topicwidget.ui
)

# Handle settingspages
target_include_directories(${TARGET} PRIVATE settingspages)
include(settingspages/settingspages.cmake)
foreach(page ${SETTINGSPAGES})
    target_sources(${TARGET} PRIVATE
        settingspages/${page}settingspage.cpp
        settingspages/${page}settingspage.ui
    )
endforeach()
foreach(src ${SP_SOURCES})
    target_sources(${TARGET} PRIVATE settingspages/${src})
endforeach()
foreach(form ${SP_FORMS})
    target_sources(${TARGET} PRIVATE settingspages/${form})
endforeach()

target_link_libraries(${TARGET}
    PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Network
        Qt5::Widgets
        Quassel::UiSupport
        Quassel::Client
        Quassel::Common
)

if (WITH_KDE)
    target_sources(${TARGET} PRIVATE knotificationbackend.cpp)
    target_link_libraries(${TARGET} PUBLIC
        KF5::ConfigWidgets
        KF5::Notifications
        KF5::NotifyConfig
        KF5::WidgetsAddons
        KF5::XmlGui
    )
endif()

if (KF5Sonnet_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_SONNET)
    target_sources(${TARGET} PRIVATE settingspages/sonnetsettingspage.cpp)
    target_link_libraries(${TARGET} PRIVATE KF5::SonnetUi)
endif()

if (Qt5Multimedia_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_QTMULTIMEDIA)
    target_sources(${TARGET} PRIVATE
        qtmultimedianotificationbackend.cpp
        qtmultimedianotificationconfigwidget.ui
    )
    target_link_libraries(${TARGET} PRIVATE Qt5::Multimedia)
endif()

if (Qt5DBus_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_DBUS)
    target_link_libraries(${TARGET} PRIVATE Qt5::DBus)
    if (dbusmenu-qt5_FOUND)
        target_compile_definitions(${TARGET} PRIVATE -DHAVE_DBUSMENU)
        target_link_libraries(${TARGET} PRIVATE dbusmenu-qt5)
    endif()

    qt5_add_dbus_interface(DBUS_SOURCES ../../interfaces/org.kde.StatusNotifierWatcher.xml statusnotifierwatcher)
    qt5_add_dbus_interface(DBUS_SOURCES ../../interfaces/org.freedesktop.Notifications.xml notificationsclient)
    qt5_add_dbus_adaptor  (DBUS_SOURCES ../../interfaces/org.kde.StatusNotifierItem.xml statusnotifieritemdbus.h StatusNotifierItemDBus)

    target_sources(${TARGET} PRIVATE
        dockmanagernotificationbackend.cpp
        statusnotifieritem.cpp
        statusnotifieritemdbus.cpp
        ${DBUS_SOURCES}
    )
endif()

if (HAVE_WEBKIT)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_WEBKIT)
    target_link_libraries(${TARGET} PRIVATE
        Qt5::WebKit
        Qt5::WebKitWidgets
    )
endif()

if (HAVE_WEBENGINE)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_WEBENGINE)
    target_link_libraries(${TARGET} PRIVATE
        Qt5::WebEngine
        Qt5::WebEngineWidgets)
endif()

if (HAVE_SSL)
    target_sources(${TARGET} PRIVATE
        sslinfodlg.cpp
        sslinfodlg.ui
    )
endif()

if (LibsnoreQt5_FOUND)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_LIBSNORE)
    target_sources(${TARGET} PRIVATE
        snorenotificationbackend.cpp
        snorentificationconfigwidget.ui
    )
    target_link_libraries(${TARGET} PRIVATE Snore::Libsnore Snore::LibsnoreSettings)
endif()

if (WITH_NOTIFICATION_CENTER)
    target_compile_definitions(${TARGET} PRIVATE -DHAVE_NOTIFICATION_CENTER)
    target_sources(${TARGET} PRIVATE osxnotificationbackend.mm)
    target_link_libraries(${TARGET} PRIVATE "/System/Library/Frameworks/Foundation.framework")
endif()

if (WITH_OXYGEN_ICONS)
    set_property(SOURCE qtui.cpp APPEND PROPERTY COMPILE_DEFINITIONS WITH_OXYGEN_ICONS)
endif()

=== tests/common/CMakeLists.txt ===
quassel_add_test(ExpressionMatchTest)

quassel_add_test(FuncHelpersTest)

quassel_add_test(SignalProxyTest
    LIBRARIES
        Quassel::Test::Util
)

=== debian/changelog ===
quassel-qt5 (0.14.0~pre-130-g01d67be2-1) unstable; urgency=medium

  * New snapshot: 0.14-pre-130-g01d67be2

 -- Alf Gaida <agaida@siduction.org>  Fri, 22 Feb 2019 00:01:12 +0100

quassel-qt5 (0.14.0~pre-110-g7c0eb011-1) unstable; urgency=medium

  * New snapshot: 0.14-pre-110-g7c0eb011

 -- Alf Gaida <agaida@siduction.org>  Fri, 23 Nov 2018 22:42:42 +0100

quassel-qt5 (0.14.0~pre-107-g95848fd9-1) unstable; urgency=medium

  * New snapshot: 0.14-pre-107-g95848fd9

 -- Alf Gaida <agaida@siduction.org>  Tue, 20 Nov 2018 20:11:38 +0100

quassel-qt5 (0.14.0~pre-100-g812b7b9f-1) unstable; urgency=medium

  * New snapshot: 0.14-pre-100-g812b7b9f

 -- Alf Gaida <agaida@siduction.org>  Sun, 18 Nov 2018 23:48:19 +0100

quassel-qt5 (0.14.0~pre-1) unstable; urgency=medium

  * New snapshot: 0.14-pre

 -- Alf Gaida <agaida@siduction.org>  Sat, 17 Nov 2018 23:35:47 +0100

quassel-qt5 (0.13~really~rc2-1) unstable; urgency=medium

  * New snapshot: 0.13-rc2

 -- Alf Gaida <agaida@siduction.org>  Sat, 20 Oct 2018 12:01:01 +0200

quassel-qt5 (0.13~really~rc1-83-g299bb290-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1-83-g299bb290

 -- Alf Gaida <agaida@siduction.org>  Wed, 03 Oct 2018 14:13:16 +0200

quassel-qt5 (0.13~really~rc1-63-gb33ea3ad-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1-63-gb33ea3ad

 -- Alf Gaida <agaida@siduction.org>  Sat, 15 Sep 2018 11:20:22 +0200

quassel-qt5 (0.13~really~rc1-58-g29252b70-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1-58-g29252b70

 -- Alf Gaida <agaida@siduction.org>  Mon, 10 Sep 2018 21:28:00 +0200

quassel-qt5 (0.13~really~rc1-27-g3b910b2c-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1-27-g3b910b2c

 -- Alf Gaida <agaida@siduction.org>  Mon, 03 Sep 2018 01:36:40 +0200

quassel-qt5 (0.13~really~rc1-25-g0b99f922-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1-25-g0b99f922

 -- Alf Gaida <agaida@siduction.org>  Thu, 30 Aug 2018 19:16:27 +0200

quassel-qt5 (0.13~really~rc1-15-gd1aa7950-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1-15-gd1aa7950

 -- Alf Gaida <agaida@siduction.org>  Fri, 24 Aug 2018 20:42:21 +0200

quassel-qt5 (0.13~really~rc1-4-g56412681-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1-4-g56412681

 -- Alf Gaida <agaida@siduction.org>  Sun, 12 Aug 2018 14:08:01 +0200

quassel-qt5 (0.13~really~rc1-1) unstable; urgency=medium

  * New snapshot: 0.13-rc1

 -- Alf Gaida <agaida@siduction.org>  Sat, 21 Jul 2018 01:09:34 +0200

quassel-qt5 (0.13~really~0.12.0-693-gda1a6f40-1) unstable; urgency=medium

  * New snapshot: 0.13-pre-693-gda1a6f40

 -- Alf Gaida <agaida@siduction.org>  Sun, 24 Jun 2018 00:05:42 +0200

quassel-qt5 (0.13~really~0.12.0-677-g932ab289-1) unstable; urgency=medium

  * New snapshot: 0.12.0-677-g932ab289

 -- Alf Gaida <agaida@siduction.org>  Mon, 18 Jun 2018 23:16:29 +0200

quassel-qt5 (0.13~really~0.12.0-676-gf7b02c31-1) unstable; urgency=medium

  * New snapshot: 0.12.0-676-gf7b02c31

 -- Alf Gaida <agaida@siduction.org>  Mon, 18 Jun 2018 22:38:12 +0200

quassel-qt5 (0.13~really~0.12.0-538-gfa344906-1) unstable; urgency=medium

  * New snapshot: 0.12.0-538-gfa344906

 -- Alf Gaida <agaida@siduction.org>  Wed, 09 May 2018 02:28:28 +0200

quassel-qt5 (0.13~really~0.12.0-531-g6e7b4039-1) unstable; urgency=medium

  * New snapshot: 0.12.0-531-g6e7b4039

 -- Alf Gaida <agaida@siduction.org>  Tue, 01 May 2018 23:04:39 +0200

quassel-qt5 (0.13~really~0.12.0-530-gced382f4-1) unstable; urgency=medium

  * New snapshot: 0.12.0-530-gced382f4

 -- Alf Gaida <agaida@siduction.org>  Tue, 01 May 2018 00:50:24 +0200

quassel-qt5 (0.13~really~0.12.0-527-ge17fca76-1) unstable; urgency=medium

  * New snapshot: 0.12.0-527-ge17fca76
  * This is technically 0.12.5

 -- Alf Gaida <agaida@siduction.org>  Tue, 24 Apr 2018 21:59:48 +0200

quassel-qt5 (0.13~really~0.12.0-524-g7a8ea3ee-1) unstable; urgency=medium

  * New snapshot: 0.12.0-524-g7a8ea3ee

 -- Alf Gaida <agaida@siduction.org>  Sat, 14 Apr 2018 14:58:03 +0200

quassel-qt5 (0.13~really~0.12.0-512-ga8360815-1) unstable; urgency=medium

  * New snapshot: 0.12.0-512-ga8360815

 -- Alf Gaida <agaida@siduction.org>  Thu, 05 Apr 2018 04:47:15 +0200

quassel-qt5 (0.13~really~0.12.0-481-g934fa415-1) unstable; urgency=medium

  * New snapshot: 0.12.0-481-g934fa415

 -- Alf Gaida <agaida@siduction.org>  Wed, 28 Feb 2018 18:30:27 +0100

quassel-qt5 (0.13~really~0.12.0-478-g91c69d07-3) unstable; urgency=medium

  * Recommend: hunspell, hunspell-de-de, hunspell-en-us

 -- Alf Gaida <agaida@siduction.org>  Wed, 28 Feb 2018 18:03:44 +0100

quassel-qt5 (0.13~really~0.12.0-478-g91c69d07-2) unstable; urgency=medium

  * Standards 4.1.3
  * dh >= 11, compat 11

 -- Alf Gaida <agaida@siduction.org>  Tue, 27 Feb 2018 23:13:48 +0100

quassel-qt5 (0.13~really~0.12.0-478-g91c69d07-1) unstable; urgency=medium

  * New snapshot: 0.12.0-478-g91c69d07

 -- Alf Gaida <agaida@siduction.org>  Tue, 27 Feb 2018 23:04:18 +0100

quassel-qt5 (0.13~really~0.12.0-472-gb8e81285-1) unstable; urgency=medium

  * fixed debian rules
  * New snapshot: 0.12.0-472-gb8e81285

 -- Alf Gaida <agaida@siduction.org>  Sun, 18 Feb 2018 20:00:32 +0100

quassel-qt5 (0.13~really~0.12.0-463-g0167e8a2-2) unstable; urgency=medium

  * added package quassel-qt5

 -- Alf Gaida <agaida@siduction.org>  Thu, 21 Dec 2017 23:41:49 +0100

quassel-qt5 (0.13~really~0.12.0-463-g0167e8a2-1) unstable; urgency=medium

  * New snapshot: 0.12.0-463-g0167e8a2
  * we need to enable some icon themes to have the selector
    --DWITH_BREEZE=ON
    --DWITH_BREEZE_DARK=ON
    --DWITH_OXYGEN=ON

 -- Alf Gaida <agaida@siduction.org>  Thu, 21 Dec 2017 22:38:45 +0100

quassel-qt5 (0.13~really~0.12.0-458-g71d3d0d7-1) unstable; urgency=medium

  * New snapshot: 0.12.0-458-g71d3d0d7

 -- Alf Gaida <agaida@siduction.org>  Thu, 21 Dec 2017 01:56:55 +0100

quassel-qt5 (0.13~really~0.12.0-448-ge90ec7aa-2) unstable; urgency=medium

  * New snapshot: 0.12.0-448-ge90ec7aa
  * Added qttools5-dev



=== debian/control ===
Source: quassel-qt5
Section: net
Priority: optional
Maintainer: Alf Gaida <agaida@siduction.org>
Build-Depends: debhelper (>= 11~),
               extra-cmake-modules,
               cmake,
               libboost1.67-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libpng-dev,
               libsm-dev,
               libice-dev,
               libxi-dev,
               libxrandr-dev,
               libxrender-dev,
               zlib1g-dev,
               libssl-dev,
               libdbus-1-dev,
               quilt,
# QT5
               libphonon4qt5-dev,
               libphonon4qt5experimental-dev,
               libdbusmenu-qt5-dev,
               libqca-qt5-2-dev,
               libqt5webkit5-dev,
# qtwebengine5-dev,
               qtmultimedia5-dev,
               qtscript5-dev,
               qttools5-dev,
               qttools5-dev-tools,
# some KF5
               libkf5sonnet-dev
Standards-Version: 4.2.1
VCS-Browser: https://git.siduction.org/snapshots/quassel
VCS-Git: https://git.siduction.org/snapshots/quassel.git
Homepage: https://www.quassel-irc.org

Package: quassel-qt5
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         quassel-data-qt5 (= ${source:Version}),
         libquassel-client (= ${binary:Version}),
         libquassel-common (= ${binary:Version}),
         libquassel-core (= ${binary:Version}),
         dbus-x11,
         phonon4qt5,
         phonon4qt5-backend-gstreamer | phonon4qt5-backend-vlc,
         gawk
Recommends: libqt5sql5-sqlite (>= 5.3.2) | libqt5sql5-psql,
            hunspell,
            hunspell-de-de,
            hunspell-en-us
Conflicts: quassel,
           quassel-client-kde4
Description: Monolitic IRC client (Qt5 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolitic client.

Package: quassel-client-qt5
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         quassel-data-qt5 (= ${source:Version}),
         libquassel-client (= ${binary:Version}),
         libquassel-common (= ${binary:Version}),
         dbus-x11,
         phonon4qt5,
         phonon4qt5-backend-gstreamer | phonon4qt5-backend-vlc,
         gawk
Recommends: libqt5sql5-sqlite (>= 5.3.2) | libqt5sql5-psql,
            hunspell,
            hunspell-de-de,
            hunspell-en-us
Conflicts: quassel,
           quassel-client-kde4
Description: distributed IRC client - Qt-based client component (Qt5 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component.

Package: quassel-core-qt5
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser,
         libquassel-common (= ${binary:Version}),
         libquassel-core (= ${binary:Version}),
         libqt5sql5-sqlite (>= 5.3.2) | libqt5sql5-psql,
         lsb-base (>= 3.2-14),
         openssl
Breaks: quassel-core
Replaces: quassel-core
Description: distributed IRC client - core component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the core component.

Package: quassel-data-qt5
Architecture: all
Depends: ${misc:Depends}
Conflicts: quassel,
           quassel-data-kde4
Replaces: quassel (<< 0.3.1-1)
Description: distributed IRC client - shared data (Qt5 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the Qt-based Quassel client
 packages.

Package: libquassel-client
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: quassel,
           quassel-data-kde4
Replaces: quassel (<< 0.3.1-1)
Description: Quassel client libs (Qt5 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provide the common library that are used by Quassel client and
 Quassel mono.

Package: libquassel-common
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: quassel,
           quassel-data-kde4
Replaces: quassel (<< 0.3.1-1)
Description: Quassel common lib (Qt5 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provide the common library that are used by the Quassel packages.

Package: libquassel-core
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: quassel,
           quassel-data-kde4
Replaces: quassel (<< 0.3.1-1)
Description: Quassel core lib (Qt5 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provide the core library that are used by the Quassel core
 and Quassel mono.

Package: libquassel-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libquassel-client (= ${binary:Version}),
         libquassel-common (= ${binary:Version}),
         libquassel-core (= ${binary:Version})
Description: Quassel lib devel (Qt5 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provide the development files used by the Quassel.

=== debian/rules ===
#!/usr/bin/make -f
export dh_verbose=1

export GIT_HEAD=$(shell [ -f debian/git_head ] && cat debian/git_head)
export GIT_DESCRIBE=$(shell [ -f debian/git_describe ] && cat debian/git_describe)
export GIT_COMMIT_DATE=$(shell [ -f debian/git_commit_date ] && cat debian/git_commit_date)

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=cmake \
		--with quilt

# we build only core and client in a single run wit Qt 5
override_dh_auto_configure:
	dh_auto_configure -- \
		-DEMBED_DEFAULT=ON \
		-DHAVE_SSL=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DWANT_MONO=ON \
		-DWITH_KDE=OFF \
		-DWITH_LDAP=OFF \
		-DWITH_WEBENGINE=OFF \
		-DWITH_WEBKIT=ON

override_dh_auto_install:
	dh_auto_install
	find debian/tmp -name LICENSE -delete

override_dh_installinit:
	dh_installinit -r --error-handler=exit --name=quasselcore

override_dh_missing:
	dh_missing --fail-missing
